#!/usr/bin/env python

from CryptoWorld.PublicKey import RSA

from pickle import dump
from getopt import getopt
from string import atoi
from sys import exit, argv
from os import chmod
from estutil import ctrlc_handler, keypair

import signal

signal.signal(signal.SIGINT, ctrlc_handler)

def usage():
    print "Usage: estkg.py -l <keylength> -f <keyfile>"
    print "       default values: (1024, key.file)"
    exit()

length = 1024
keyfile = "key.file"

try:
    optlist, args = getopt(argv[1:], "l:f:")
except:
    usage()

if (len(args) > 0):
    usage()

for flag, arg in optlist:
    if (flag == "-l"): length = atoi(arg)
    elif (flag == "-f"): keyfile = arg

pair = RSA()
pair.generate_key(length, 3)

estpair = keypair()
estpair.public_key = pair.get_public_key()
estpair.private_key = pair.get_private_key()

file = open(keyfile, "w")
dump(estpair, file)
file.close()

chmod(keyfile, 0 | 256 | 128)
